#! /bin/sh

topdir=`pwd`

tar zxf gsoap_2.7.9i.tar.gz
patch -p0 < gsoap_2.7.9i.diff
rm gsoap-2.7/soapcpp2/stdsoap2_cpp.cpp

# build and install gsoap
if test -x "`which pkg-config`"; then
	CPPFLAGS="`pkg-config --cflags openssl`"
	LDFLAGS="`pkg-config --libs openssl`"
	export CPPFLAGS
	export LDFLAGS
fi

cd gsoap-2.7
./configure --prefix=$topdir/INSTALL
make
make install
cd $topdir

(cd $topdir/INSTALL && tar xf $topdir/schemas.tar)

cd $topdir

tar zxf xacml-1.0.tar.gz
cd xacml-1.0
./configure   --with-schema-dir=$topdir/INSTALL/share/schema/core/security/authorization/xacml \
              --with-gsoap=$topdir/INSTALL \
              --prefix=$topdir/INSTALL
make
make install
